#! /usr/bin/python3

import sys

sys.path.insert(1, '../../scripts')

from readMCD import readMCD

def printUsageAndExit() :
  print("USAGE : %s mcd column_1.txt columns_2.txt..."%sys.argv[0], file=sys.stderr)
  exit(1)

if __name__ == "__main__" :

  sys.stdout = open(1, 'w', encoding='utf-8', closefd=False)

  if len(sys.argv) < 3 :
    printUsageAndExit()

  conllMCD, conllMCDr = readMCD(sys.argv[1])

  for colFile in sys.argv[2:] :
    numCol = int(colFile.split('.')[0].split('_')[-1]) -1
    if not numCol in conllMCD :
      continue
    nameCol = conllMCD[numCol]

    if nameCol == "UPOS" :
      output = open("tagger.ts", 'w', encoding='utf-8')
      for line in open(colFile, "r", encoding='utf-8') :
        striped = line.strip()
        if len(striped) == 0 :
          continue
        print("<tagger> WRITE b.0 UPOS " + striped, file=output)
      output.close()

    elif nameCol == "XPOS" :
      output = open("taggerx.ts", 'w', encoding='utf-8')
      for line in open(colFile, "r", encoding='utf-8') :
        striped = line.strip()
        if len(striped) == 0 :
          continue
        print("WRITE b.0 XPOS " + striped, file=output)
      output.close()

    elif nameCol == "FEATS" :
      output = open("morpho_whole.ts", 'w', encoding='utf-8')
      for line in open(colFile, "r", encoding='utf-8') :
        striped = line.strip()
        if len(striped) == 0 :
          continue
        print("WRITE b.0 FEATS " + striped, file=output)
      output.close()
      output = open("morpho_parts.ts", 'w', encoding='utf-8')
      allParts = set()
      allPartsList = []
      for line in open(colFile, "r", encoding='utf-8') :
        striped = line.strip()
        if len(striped) == 0 :
          continue
        parts = striped.split('|')
        for part in parts :
          allParts.add(part)
      for part in allParts :
        allPartsList.append(part)
      allPartsList.sort()
      for part in allPartsList :
        print("ADD b.0 FEATS " + part, file=output)
      print("NOTHING", file=output)
      output.close()

    elif nameCol == "DEPREL" :
      output = open("parser_legacy.ts", 'w', encoding='utf-8')
      print("REDUCE", file=output)
      labels = set()
      labelsList = []
      for line in open(colFile, "r", encoding='utf-8') :
        striped = line.strip()
        if len(striped) == 0 or striped == "root" or striped == "_" :
          continue
        label = striped.split(':')[0]
        if label not in labels :
          labels.add(striped)
          labelsList.append(striped)
      labelsList.sort()
      for label in labelsList :
        print("LEFT " + label, file=output)
        print("RIGHT " + label, file=output)
      print("EOS s.0", file=output)
      print("SHIFT", file=output)
      output.close()
      output = open("parser.ts", 'w', encoding='utf-8')
      print("<parser> REDUCE", file=output)
      labels = set()
      labelsList = []
      for line in open(colFile, "r", encoding='utf-8') :
        striped = line.strip()
        if len(striped) == 0 or striped == "root" or striped == "_" :
          continue
        label = striped.split(':')[0]
        if label not in labels :
          labels.add(striped)
          labelsList.append(striped)
      labelsList.sort()
      for label in labelsList :
        print("<parser> LEFT " + label, file=output)
        print("<parser> RIGHT " + label, file=output)
      print("<parser> EOS", file=output)
      print("<parser> SHIFT", file=output)
      output.close()

